import { Buffer } from '../buffer';
import { Context } from '../context';
import { Geometry } from '../geometry';
import { Material } from '../scene';
export declare class IndexBinding {
    buffer: Buffer;
    type: GLenum;
    numIndices: number;
    offset: GLintptr;
}
export declare class VertexBinding {
    buffer: Buffer;
    attributeIndex: GLint;
    numVertices: GLint;
    size: GLint;
    type: GLenum;
    normalized: boolean;
    stride: GLsizei;
    offset: GLintptr;
}
export declare class GLTFPrimitive extends Geometry {
    protected _drawMode: GLenum;
    protected _indexBinding: IndexBinding | undefined;
    protected _bindings: Array<VertexBinding>;
    protected _material: Material;
    protected _geometryFlags: number;
    constructor(context: Context, bindings: Array<VertexBinding>, indexBinding: IndexBinding | undefined, drawMode: GLenum, material: Material, flags: number, identifier?: string);
    protected bindBuffers(): void;
    protected unbindBuffers(): void;
    draw(): void;
    get material(): Material;
    get flags(): number;
}
